# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 4.6.0-SNAPSHOT
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class PathnexusQueryModel(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'specimens': 'list[str]',
        'statuses': 'list[str]',
        'constituents': 'list[str]',
        'properties': 'list[str]',
        'parent_ids': 'list[str]',
        'tags': 'list[str]',
        'phases': 'list[str]',
        'snomed_ids': 'list[int]',
        'token': 'str',
        'locked': 'list[bool]',
        'inactive': 'list[bool]',
        'requestables': 'list[bool]',
        'added_date': 'int',
        'updated_date': 'int',
        'inactivation_date': 'int',
        'algorithms': 'list[str]',
        'report': 'list[bool]',
        'request': 'list[bool]',
        'battery': 'list[bool]',
        'level': 'list[bool]',
        'test': 'list[bool]',
        'pbcl_boolean': 'list[bool]',
        'pbcl_text': 'list[bool]',
        'ratio': 'list[bool]',
        'states': 'list[str]',
        'processors': 'dict(str, str)',
        'include_sct_matches': 'bool',
        'categories': 'list[int]',
        'stated_ecl_filter': 'str',
        'ecl_filter': 'str',
        'branch': 'str',
        'specimen': 'bool'
    }

    attribute_map = {
        'specimens': 'specimens',
        'statuses': 'statuses',
        'constituents': 'constituents',
        'properties': 'properties',
        'parent_ids': 'parentIds',
        'tags': 'tags',
        'phases': 'phases',
        'snomed_ids': 'snomedIds',
        'token': 'token',
        'locked': 'locked',
        'inactive': 'inactive',
        'requestables': 'requestables',
        'added_date': 'addedDate',
        'updated_date': 'updatedDate',
        'inactivation_date': 'inactivationDate',
        'algorithms': 'algorithms',
        'report': 'report',
        'request': 'request',
        'battery': 'battery',
        'level': 'level',
        'test': 'test',
        'pbcl_boolean': 'pbclBoolean',
        'pbcl_text': 'pbclText',
        'ratio': 'ratio',
        'states': 'states',
        'processors': 'processors',
        'include_sct_matches': 'includeSctMatches',
        'categories': 'categories',
        'stated_ecl_filter': 'statedEclFilter',
        'ecl_filter': 'eclFilter',
        'branch': 'branch',
        'specimen': 'specimen'
    }

    def __init__(self, specimens=None, statuses=None, constituents=None, properties=None, parent_ids=None, tags=None, phases=None, snomed_ids=None, token=None, locked=None, inactive=None, requestables=None, added_date=None, updated_date=None, inactivation_date=None, algorithms=None, report=None, request=None, battery=None, level=None, test=None, pbcl_boolean=None, pbcl_text=None, ratio=None, states=None, processors=None, include_sct_matches=None, categories=None, stated_ecl_filter=None, ecl_filter=None, branch=None, specimen=None):  # noqa: E501
        """PathnexusQueryModel - a model defined in Swagger"""  # noqa: E501

        self._specimens = None
        self._statuses = None
        self._constituents = None
        self._properties = None
        self._parent_ids = None
        self._tags = None
        self._phases = None
        self._snomed_ids = None
        self._token = None
        self._locked = None
        self._inactive = None
        self._requestables = None
        self._added_date = None
        self._updated_date = None
        self._inactivation_date = None
        self._algorithms = None
        self._report = None
        self._request = None
        self._battery = None
        self._level = None
        self._test = None
        self._pbcl_boolean = None
        self._pbcl_text = None
        self._ratio = None
        self._states = None
        self._processors = None
        self._include_sct_matches = None
        self._categories = None
        self._stated_ecl_filter = None
        self._ecl_filter = None
        self._branch = None
        self._specimen = None
        self.discriminator = None

        if specimens is not None:
            self.specimens = specimens
        if statuses is not None:
            self.statuses = statuses
        if constituents is not None:
            self.constituents = constituents
        if properties is not None:
            self.properties = properties
        if parent_ids is not None:
            self.parent_ids = parent_ids
        if tags is not None:
            self.tags = tags
        if phases is not None:
            self.phases = phases
        if snomed_ids is not None:
            self.snomed_ids = snomed_ids
        if token is not None:
            self.token = token
        if locked is not None:
            self.locked = locked
        if inactive is not None:
            self.inactive = inactive
        if requestables is not None:
            self.requestables = requestables
        if added_date is not None:
            self.added_date = added_date
        if updated_date is not None:
            self.updated_date = updated_date
        if inactivation_date is not None:
            self.inactivation_date = inactivation_date
        if algorithms is not None:
            self.algorithms = algorithms
        if report is not None:
            self.report = report
        if request is not None:
            self.request = request
        if battery is not None:
            self.battery = battery
        if level is not None:
            self.level = level
        if test is not None:
            self.test = test
        if pbcl_boolean is not None:
            self.pbcl_boolean = pbcl_boolean
        if pbcl_text is not None:
            self.pbcl_text = pbcl_text
        if ratio is not None:
            self.ratio = ratio
        if states is not None:
            self.states = states
        if processors is not None:
            self.processors = processors
        if include_sct_matches is not None:
            self.include_sct_matches = include_sct_matches
        if categories is not None:
            self.categories = categories
        if stated_ecl_filter is not None:
            self.stated_ecl_filter = stated_ecl_filter
        if ecl_filter is not None:
            self.ecl_filter = ecl_filter
        if branch is not None:
            self.branch = branch
        if specimen is not None:
            self.specimen = specimen

    @property
    def specimens(self):
        """Gets the specimens of this PathnexusQueryModel.  # noqa: E501


        :return: The specimens of this PathnexusQueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._specimens

    @specimens.setter
    def specimens(self, specimens):
        """Sets the specimens of this PathnexusQueryModel.


        :param specimens: The specimens of this PathnexusQueryModel.  # noqa: E501
        :type: list[str]
        """

        self._specimens = specimens

    @property
    def statuses(self):
        """Gets the statuses of this PathnexusQueryModel.  # noqa: E501


        :return: The statuses of this PathnexusQueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._statuses

    @statuses.setter
    def statuses(self, statuses):
        """Sets the statuses of this PathnexusQueryModel.


        :param statuses: The statuses of this PathnexusQueryModel.  # noqa: E501
        :type: list[str]
        """
        allowed_values = ["DRAFT", "PUBLISHED", "TRIAL", "ACTIVE", "DISCOURAGED", "DEPRECATED", "REVIEW"]  # noqa: E501
        if not set(statuses).issubset(set(allowed_values)):
            raise ValueError(
                "Invalid values for `statuses` [{0}], must be a subset of [{1}]"  # noqa: E501
                .format(", ".join(map(str, set(statuses) - set(allowed_values))),  # noqa: E501
                        ", ".join(map(str, allowed_values)))
            )

        self._statuses = statuses

    @property
    def constituents(self):
        """Gets the constituents of this PathnexusQueryModel.  # noqa: E501


        :return: The constituents of this PathnexusQueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._constituents

    @constituents.setter
    def constituents(self, constituents):
        """Sets the constituents of this PathnexusQueryModel.


        :param constituents: The constituents of this PathnexusQueryModel.  # noqa: E501
        :type: list[str]
        """

        self._constituents = constituents

    @property
    def properties(self):
        """Gets the properties of this PathnexusQueryModel.  # noqa: E501


        :return: The properties of this PathnexusQueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this PathnexusQueryModel.


        :param properties: The properties of this PathnexusQueryModel.  # noqa: E501
        :type: list[str]
        """

        self._properties = properties

    @property
    def parent_ids(self):
        """Gets the parent_ids of this PathnexusQueryModel.  # noqa: E501


        :return: The parent_ids of this PathnexusQueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._parent_ids

    @parent_ids.setter
    def parent_ids(self, parent_ids):
        """Sets the parent_ids of this PathnexusQueryModel.


        :param parent_ids: The parent_ids of this PathnexusQueryModel.  # noqa: E501
        :type: list[str]
        """

        self._parent_ids = parent_ids

    @property
    def tags(self):
        """Gets the tags of this PathnexusQueryModel.  # noqa: E501


        :return: The tags of this PathnexusQueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this PathnexusQueryModel.


        :param tags: The tags of this PathnexusQueryModel.  # noqa: E501
        :type: list[str]
        """

        self._tags = tags

    @property
    def phases(self):
        """Gets the phases of this PathnexusQueryModel.  # noqa: E501


        :return: The phases of this PathnexusQueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._phases

    @phases.setter
    def phases(self, phases):
        """Sets the phases of this PathnexusQueryModel.


        :param phases: The phases of this PathnexusQueryModel.  # noqa: E501
        :type: list[str]
        """
        allowed_values = ["PREALPHA", "ALPHA", "BETA", "PROD", "UNKNOWN"]  # noqa: E501
        if not set(phases).issubset(set(allowed_values)):
            raise ValueError(
                "Invalid values for `phases` [{0}], must be a subset of [{1}]"  # noqa: E501
                .format(", ".join(map(str, set(phases) - set(allowed_values))),  # noqa: E501
                        ", ".join(map(str, allowed_values)))
            )

        self._phases = phases

    @property
    def snomed_ids(self):
        """Gets the snomed_ids of this PathnexusQueryModel.  # noqa: E501


        :return: The snomed_ids of this PathnexusQueryModel.  # noqa: E501
        :rtype: list[int]
        """
        return self._snomed_ids

    @snomed_ids.setter
    def snomed_ids(self, snomed_ids):
        """Sets the snomed_ids of this PathnexusQueryModel.


        :param snomed_ids: The snomed_ids of this PathnexusQueryModel.  # noqa: E501
        :type: list[int]
        """

        self._snomed_ids = snomed_ids

    @property
    def token(self):
        """Gets the token of this PathnexusQueryModel.  # noqa: E501


        :return: The token of this PathnexusQueryModel.  # noqa: E501
        :rtype: str
        """
        return self._token

    @token.setter
    def token(self, token):
        """Sets the token of this PathnexusQueryModel.


        :param token: The token of this PathnexusQueryModel.  # noqa: E501
        :type: str
        """

        self._token = token

    @property
    def locked(self):
        """Gets the locked of this PathnexusQueryModel.  # noqa: E501


        :return: The locked of this PathnexusQueryModel.  # noqa: E501
        :rtype: list[bool]
        """
        return self._locked

    @locked.setter
    def locked(self, locked):
        """Sets the locked of this PathnexusQueryModel.


        :param locked: The locked of this PathnexusQueryModel.  # noqa: E501
        :type: list[bool]
        """

        self._locked = locked

    @property
    def inactive(self):
        """Gets the inactive of this PathnexusQueryModel.  # noqa: E501


        :return: The inactive of this PathnexusQueryModel.  # noqa: E501
        :rtype: list[bool]
        """
        return self._inactive

    @inactive.setter
    def inactive(self, inactive):
        """Sets the inactive of this PathnexusQueryModel.


        :param inactive: The inactive of this PathnexusQueryModel.  # noqa: E501
        :type: list[bool]
        """

        self._inactive = inactive

    @property
    def requestables(self):
        """Gets the requestables of this PathnexusQueryModel.  # noqa: E501


        :return: The requestables of this PathnexusQueryModel.  # noqa: E501
        :rtype: list[bool]
        """
        return self._requestables

    @requestables.setter
    def requestables(self, requestables):
        """Sets the requestables of this PathnexusQueryModel.


        :param requestables: The requestables of this PathnexusQueryModel.  # noqa: E501
        :type: list[bool]
        """

        self._requestables = requestables

    @property
    def added_date(self):
        """Gets the added_date of this PathnexusQueryModel.  # noqa: E501


        :return: The added_date of this PathnexusQueryModel.  # noqa: E501
        :rtype: int
        """
        return self._added_date

    @added_date.setter
    def added_date(self, added_date):
        """Sets the added_date of this PathnexusQueryModel.


        :param added_date: The added_date of this PathnexusQueryModel.  # noqa: E501
        :type: int
        """

        self._added_date = added_date

    @property
    def updated_date(self):
        """Gets the updated_date of this PathnexusQueryModel.  # noqa: E501


        :return: The updated_date of this PathnexusQueryModel.  # noqa: E501
        :rtype: int
        """
        return self._updated_date

    @updated_date.setter
    def updated_date(self, updated_date):
        """Sets the updated_date of this PathnexusQueryModel.


        :param updated_date: The updated_date of this PathnexusQueryModel.  # noqa: E501
        :type: int
        """

        self._updated_date = updated_date

    @property
    def inactivation_date(self):
        """Gets the inactivation_date of this PathnexusQueryModel.  # noqa: E501


        :return: The inactivation_date of this PathnexusQueryModel.  # noqa: E501
        :rtype: int
        """
        return self._inactivation_date

    @inactivation_date.setter
    def inactivation_date(self, inactivation_date):
        """Sets the inactivation_date of this PathnexusQueryModel.


        :param inactivation_date: The inactivation_date of this PathnexusQueryModel.  # noqa: E501
        :type: int
        """

        self._inactivation_date = inactivation_date

    @property
    def algorithms(self):
        """Gets the algorithms of this PathnexusQueryModel.  # noqa: E501


        :return: The algorithms of this PathnexusQueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._algorithms

    @algorithms.setter
    def algorithms(self, algorithms):
        """Sets the algorithms of this PathnexusQueryModel.


        :param algorithms: The algorithms of this PathnexusQueryModel.  # noqa: E501
        :type: list[str]
        """
        allowed_values = ["EXACT_MATCH", "EXACT_MATCH_IGNORE_CASE", "STARTS_WITH", "STARTS_WITH_IGNORE_CASE", "ENDS_WITH", "ENDS_WITH_IGNORE_CASE", "PHRASE_MATCH", "PHRASE_MATCH_IGNORE_CASE", "WILD_CARDS", "WILD_CARDS_IGNORE_CASE", "PHRASE_UNORDERED", "PHRASE_UNORDERED_IGNORE_CASE", "REGEX", "FUZZY"]  # noqa: E501
        if not set(algorithms).issubset(set(allowed_values)):
            raise ValueError(
                "Invalid values for `algorithms` [{0}], must be a subset of [{1}]"  # noqa: E501
                .format(", ".join(map(str, set(algorithms) - set(allowed_values))),  # noqa: E501
                        ", ".join(map(str, allowed_values)))
            )

        self._algorithms = algorithms

    @property
    def report(self):
        """Gets the report of this PathnexusQueryModel.  # noqa: E501


        :return: The report of this PathnexusQueryModel.  # noqa: E501
        :rtype: list[bool]
        """
        return self._report

    @report.setter
    def report(self, report):
        """Sets the report of this PathnexusQueryModel.


        :param report: The report of this PathnexusQueryModel.  # noqa: E501
        :type: list[bool]
        """

        self._report = report

    @property
    def request(self):
        """Gets the request of this PathnexusQueryModel.  # noqa: E501


        :return: The request of this PathnexusQueryModel.  # noqa: E501
        :rtype: list[bool]
        """
        return self._request

    @request.setter
    def request(self, request):
        """Sets the request of this PathnexusQueryModel.


        :param request: The request of this PathnexusQueryModel.  # noqa: E501
        :type: list[bool]
        """

        self._request = request

    @property
    def battery(self):
        """Gets the battery of this PathnexusQueryModel.  # noqa: E501


        :return: The battery of this PathnexusQueryModel.  # noqa: E501
        :rtype: list[bool]
        """
        return self._battery

    @battery.setter
    def battery(self, battery):
        """Sets the battery of this PathnexusQueryModel.


        :param battery: The battery of this PathnexusQueryModel.  # noqa: E501
        :type: list[bool]
        """

        self._battery = battery

    @property
    def level(self):
        """Gets the level of this PathnexusQueryModel.  # noqa: E501


        :return: The level of this PathnexusQueryModel.  # noqa: E501
        :rtype: list[bool]
        """
        return self._level

    @level.setter
    def level(self, level):
        """Sets the level of this PathnexusQueryModel.


        :param level: The level of this PathnexusQueryModel.  # noqa: E501
        :type: list[bool]
        """

        self._level = level

    @property
    def test(self):
        """Gets the test of this PathnexusQueryModel.  # noqa: E501


        :return: The test of this PathnexusQueryModel.  # noqa: E501
        :rtype: list[bool]
        """
        return self._test

    @test.setter
    def test(self, test):
        """Sets the test of this PathnexusQueryModel.


        :param test: The test of this PathnexusQueryModel.  # noqa: E501
        :type: list[bool]
        """

        self._test = test

    @property
    def pbcl_boolean(self):
        """Gets the pbcl_boolean of this PathnexusQueryModel.  # noqa: E501


        :return: The pbcl_boolean of this PathnexusQueryModel.  # noqa: E501
        :rtype: list[bool]
        """
        return self._pbcl_boolean

    @pbcl_boolean.setter
    def pbcl_boolean(self, pbcl_boolean):
        """Sets the pbcl_boolean of this PathnexusQueryModel.


        :param pbcl_boolean: The pbcl_boolean of this PathnexusQueryModel.  # noqa: E501
        :type: list[bool]
        """

        self._pbcl_boolean = pbcl_boolean

    @property
    def pbcl_text(self):
        """Gets the pbcl_text of this PathnexusQueryModel.  # noqa: E501


        :return: The pbcl_text of this PathnexusQueryModel.  # noqa: E501
        :rtype: list[bool]
        """
        return self._pbcl_text

    @pbcl_text.setter
    def pbcl_text(self, pbcl_text):
        """Sets the pbcl_text of this PathnexusQueryModel.


        :param pbcl_text: The pbcl_text of this PathnexusQueryModel.  # noqa: E501
        :type: list[bool]
        """

        self._pbcl_text = pbcl_text

    @property
    def ratio(self):
        """Gets the ratio of this PathnexusQueryModel.  # noqa: E501


        :return: The ratio of this PathnexusQueryModel.  # noqa: E501
        :rtype: list[bool]
        """
        return self._ratio

    @ratio.setter
    def ratio(self, ratio):
        """Sets the ratio of this PathnexusQueryModel.


        :param ratio: The ratio of this PathnexusQueryModel.  # noqa: E501
        :type: list[bool]
        """

        self._ratio = ratio

    @property
    def states(self):
        """Gets the states of this PathnexusQueryModel.  # noqa: E501


        :return: The states of this PathnexusQueryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._states

    @states.setter
    def states(self, states):
        """Sets the states of this PathnexusQueryModel.


        :param states: The states of this PathnexusQueryModel.  # noqa: E501
        :type: list[str]
        """
        allowed_values = ["DRAFT_PREALPHA", "REVIEW_PREALPHA", "READY_FOR_ALPHA", "REVIEW_ALPHA", "READY_FOR_BETA", "REVIEW_BETA", "PUBLISHED_PROD", "UNPUBLISHED"]  # noqa: E501
        if not set(states).issubset(set(allowed_values)):
            raise ValueError(
                "Invalid values for `states` [{0}], must be a subset of [{1}]"  # noqa: E501
                .format(", ".join(map(str, set(states) - set(allowed_values))),  # noqa: E501
                        ", ".join(map(str, allowed_values)))
            )

        self._states = states

    @property
    def processors(self):
        """Gets the processors of this PathnexusQueryModel.  # noqa: E501


        :return: The processors of this PathnexusQueryModel.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._processors

    @processors.setter
    def processors(self, processors):
        """Sets the processors of this PathnexusQueryModel.


        :param processors: The processors of this PathnexusQueryModel.  # noqa: E501
        :type: dict(str, str)
        """

        self._processors = processors

    @property
    def include_sct_matches(self):
        """Gets the include_sct_matches of this PathnexusQueryModel.  # noqa: E501


        :return: The include_sct_matches of this PathnexusQueryModel.  # noqa: E501
        :rtype: bool
        """
        return self._include_sct_matches

    @include_sct_matches.setter
    def include_sct_matches(self, include_sct_matches):
        """Sets the include_sct_matches of this PathnexusQueryModel.


        :param include_sct_matches: The include_sct_matches of this PathnexusQueryModel.  # noqa: E501
        :type: bool
        """

        self._include_sct_matches = include_sct_matches

    @property
    def categories(self):
        """Gets the categories of this PathnexusQueryModel.  # noqa: E501


        :return: The categories of this PathnexusQueryModel.  # noqa: E501
        :rtype: list[int]
        """
        return self._categories

    @categories.setter
    def categories(self, categories):
        """Sets the categories of this PathnexusQueryModel.


        :param categories: The categories of this PathnexusQueryModel.  # noqa: E501
        :type: list[int]
        """

        self._categories = categories

    @property
    def stated_ecl_filter(self):
        """Gets the stated_ecl_filter of this PathnexusQueryModel.  # noqa: E501


        :return: The stated_ecl_filter of this PathnexusQueryModel.  # noqa: E501
        :rtype: str
        """
        return self._stated_ecl_filter

    @stated_ecl_filter.setter
    def stated_ecl_filter(self, stated_ecl_filter):
        """Sets the stated_ecl_filter of this PathnexusQueryModel.


        :param stated_ecl_filter: The stated_ecl_filter of this PathnexusQueryModel.  # noqa: E501
        :type: str
        """

        self._stated_ecl_filter = stated_ecl_filter

    @property
    def ecl_filter(self):
        """Gets the ecl_filter of this PathnexusQueryModel.  # noqa: E501


        :return: The ecl_filter of this PathnexusQueryModel.  # noqa: E501
        :rtype: str
        """
        return self._ecl_filter

    @ecl_filter.setter
    def ecl_filter(self, ecl_filter):
        """Sets the ecl_filter of this PathnexusQueryModel.


        :param ecl_filter: The ecl_filter of this PathnexusQueryModel.  # noqa: E501
        :type: str
        """

        self._ecl_filter = ecl_filter

    @property
    def branch(self):
        """Gets the branch of this PathnexusQueryModel.  # noqa: E501


        :return: The branch of this PathnexusQueryModel.  # noqa: E501
        :rtype: str
        """
        return self._branch

    @branch.setter
    def branch(self, branch):
        """Sets the branch of this PathnexusQueryModel.


        :param branch: The branch of this PathnexusQueryModel.  # noqa: E501
        :type: str
        """

        self._branch = branch

    @property
    def specimen(self):
        """Gets the specimen of this PathnexusQueryModel.  # noqa: E501


        :return: The specimen of this PathnexusQueryModel.  # noqa: E501
        :rtype: bool
        """
        return self._specimen

    @specimen.setter
    def specimen(self, specimen):
        """Sets the specimen of this PathnexusQueryModel.


        :param specimen: The specimen of this PathnexusQueryModel.  # noqa: E501
        :type: bool
        """

        self._specimen = specimen

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PathnexusQueryModel):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
